PROGRAM SHEARFROMDROPS

implicit none

INTEGER,PARAMETER :: nlev=10,nlay=6
INTEGER           :: i,j,k,iost,endoffile,out_noerror=0
INTEGER           :: idate,itime,fixdate,fixtime,dumi,nplevs
INTEGER           :: npts,nptsdrop,wspd,wdir,gflag(50),numdrops
REAL              :: hdiff,mindiff,sdiff,pnow,rdate,dumr,gtime
REAL              :: spd,dir,slat,slon,latdist,londist
REAL              :: prevlat,prevlon,uv,vv,udrop,vdrop,unvdrop,vnvdrop
REAL              :: unmdrop,vnmdrop,unvnmdrop,vnvnmdrop
REAL              :: u, v, p, unow, vnow, utrack, vtrack,dist,merid
REAL              :: unv,vnv,latdist2,londist2,azimuth,rcos,rsin
REAL              :: unm, vnm, unvnm, vnvnm,minlat,maxlat, minlon,maxlon
REAL              :: newlat,newlon,ushear,vshear,shearmag,sheardir
REAL              :: latnow,lonnow,mindist,maxdist,minp,maxp,plotdir
REAL,dimension(nlev+nlay) :: uavg,vavg,unvavg,vnvavg,unmavg,vnmavg,unvnmavg,vnvnmavg
REAL,dimension(nlev)      :: plevs
REAL,dimension(nlay,2)    ::plays 
REAL              :: kts2ms=0.5144, ms2kts=1.945,deg2rad=0.14772,rad2deg=57.2246
REAL              :: deg2km=111.3200,m2deg=0.000008983,badval=-99.0,missval=-999.0
REAL,dimension(11,1000,10)  :: gradsdat
REAL,dimension(11,1000,6)   :: gradsdat2
REAL,dimension(10,5,4)     :: sheardat
REAL,dimension(3,3)        :: motion
CHARACTER(len=15)          :: frdfile, pointsfile
CHARACTER(len=12)          :: hsafile='DROP_HSA.dat',ctime
CHARACTER(len=3)           :: dirtrack, spdtrack
CHARACTER(len=6)           :: clat,clon,dumc
CHARACTER(len=8)           :: sta(1000),stid
CHARACTER(len=5)           :: stanum
CHARACTER(len=72)          :: format_hsa='(I2,X,F7.0,X,I4,X,F7.3,X,F8.3,X,3(F6.1,X),F7.1,X,2(F6.1,X),A4,X,A5,X,A2)'

call getarg(1,spdtrack)
call getarg(2,dirtrack)
call getarg(3,clat)
call getarg(4,clon)
call getarg(5,ctime)

read(spdtrack,'(I3)') wspd
read(dirtrack,'(I3)') wdir
read(clat,'(F5.1)') slat
read(clon,'(F6.1)') slon
read(ctime(1:8),'(I8)') fixdate
read(ctime(9:12),'(I4)') fixtime

fixtime=(fixtime/100)*60 + mod(fixtime,100)
plevs=(/925.,850.,700.,600.,500.,400.,300.,250.,200.,150./)
minlat=90.0
maxlat=0.0
minlon=180
maxlon=-180

do i = 1,nlev
  print *, 'PLEV ',i,'=',plevs(i)
enddo

!Convert Storm motion to u and v
!Storm motion is toward
deg2rad=atan(1.0)/45.0
spd=wspd*kts2ms
wdir=90-wdir

if (wdir.lt.0)then
   wdir=wdir+360
endif

dir=wdir*deg2rad
utrack=spd*cos(dir)
vtrack=spd*sin(dir)

print *, 'storm motion u=',utrack,'v=',vtrack
!Get scaling for longitude
merid=cos(slat*deg2rad)
!Use distance of 200-800km
mindist=200.
maxdist=800.

plays(1,1)=925
plays(1,2)=700
plays(2,1)=600
plays(2,2)=400
plays(3,1)=300
plays(3,2)=150
plays(4,1)=850
plays(4,2)=700
plays(5,1)=850
plays(5,2)=400
plays(6,1)=850
plays(6,2)=200

j=0

do i = 1, nlev
   numdrops=0
   endoffile=0
   npts=0
   nptsdrop=0
   u=0.0
   v=0.0
   udrop=0.0
   unv=0.0
   vnv=0.0
   unm=0.0
   vnm=0.0
   unvnm=0.0
   vnvnm=0.0
   unvdrop=0.0
   vnvdrop=0.0

   minp=plevs(i)-50
   maxp=plevs(i)+50

   open(unit=20,file=hsafile,status='old',form='formatted',iostat=iost)
   rewind(20)
   if(iost.ne.out_noerror)then
      print *, 'Error opening HSA file: ',iost
      exit
   endif

   do while (endoffile==0)
      read(20,fmt=format_hsa,iostat=iost) dumi, rdate, itime, latnow,lonnow,pnow,&
                              dumr, dumr,dumr,unow,vnow,dumc,dumc,dumc

      if(iost.ne.out_noerror) then
         print *, 'End of hsa file'
         endoffile=1
      endif

      if(lonnow.eq.badval)then
         lonnow=prevlon
      endif
      if(latnow.eq.badval)then
         latnow=prevlat
      endif
     
 
      if(pnow.eq.1070.0)then
         pnow=dumr
         numdrops=numdrops+1
print *, 'finished with drop ',numdrops
         lonnow=-lonnow
         gradsdat(1,numdrops,i)=latnow
         gradsdat(2,numdrops,i)=lonnow
         
         if(latnow.lt.minlat)then
            minlat=latnow
         endif
         if(latnow.gt.maxlat)then
            maxlat=latnow
         endif
         if(lonnow.lt.minlon)then
             minlon=lonnow
         endif
         if(lonnow.gt.maxlon)then
            maxlon=lonnow
         endif

        if(nptsdrop.ge.1)then
            gradsdat(3,numdrops,i)=udrop/nptsdrop
            gradsdat(4,numdrops,i)=vdrop/nptsdrop
            gradsdat(11,numdrops,i)=0.0
            gradsdat(5,numdrops,i)=unvdrop/nptsdrop
            gradsdat(6,numdrops,i)=vnvdrop/nptsdrop
            gradsdat(7,numdrops,i)=(udrop/nptsdrop)-utrack
            gradsdat(8,numdrops,i)=(vdrop/nptsdrop)-vtrack
            gradsdat(9,numdrops,i)=(unvdrop/nptsdrop)-utrack
            gradsdat(10,numdrops,i)=(vnvdrop/nptsdrop)-vtrack

         else
            gradsdat(3,numdrops,i)=missval
            gradsdat(4,numdrops,i)=missval
            gradsdat(11,numdrops,i)=1.0
            gradsdat(5,numdrops,i)=missval
            gradsdat(6,numdrops,i)=missval
            gradsdat(7,numdrops,i)=missval
            gradsdat(8,numdrops,i)=missval
            gradsdat(9,numdrops,i)=missval
            gradsdat(10,numdrops,i)=missval

         endif

         j=j+1
         write(stanum,'(I5.5)') j
         stid="STA"//stanum
         sta(j)=stid
         nptsdrop=0
         udrop=0.0
         vdrop=0.0
         unvdrop=0.0
         vnvdrop=0.0
         unmdrop=0.0
         vnmdrop=0.0
         unvnmdrop=0.0
         vnvnmdrop=0.0
      endif

      if(pnow.le.maxp.and.pnow.ge.minp)then
         rdate=rdate+20000000.
         itime=(itime/100)*60 + mod(itime,100)
         if(rdate.lt.fixdate)then
             mindiff=(1440-itime) + fixtime
             mindiff=-mindiff
         endif

         if(rdate.gt.fixdate)then
             mindiff=(1400-fixtime) + itime
         endif

         if(rdate.eq.fixdate)then
             mindiff=itime - fixtime 
         endif
              
         sdiff=mindiff*60

         lonnow=-lonnow
         newlat=slat+(sdiff*vtrack*m2deg)
         newlon=slon+(sdiff*utrack*m2deg*merid)
         latdist=(latnow-newlat)*deg2km
         latdist2=latdist*latdist
         londist=(lonnow-newlon)*deg2km*merid
         londist2=londist*londist
         dist=sqrt(latdist2+londist2)
         azimuth=atan2(latdist,londist)
         !azimuth=asin(1.)-azimuth
         rsin=sin(azimuth)
         rcos=cos(azimuth)
         if(dist.ge.mindist.and.dist.le.maxdist)then
            if(unow.ne.badval.and.vnow.ne.badval)then
               u=u+unow
               v=v+vnow
               udrop=udrop+unow
               vdrop=vdrop+vnow
               uv=-rsin*unow
               vv=rcos*vnow
               unv=unv+unow-uv
               vnv=vnv+vnow-vv
               unvdrop=unvdrop+unow-uv
               vnvdrop=vnvdrop+vnow-vv
               npts=npts+1
               nptsdrop=nptsdrop+1

            endif
         endif
      endif
     prevlat=latnow
     prevlon=lonnow
   enddo
  
   if(npts.gt.0) then
      u=u/npts
      v=v/npts
      unv=unv/npts
      vnv=vnv/npts
      unm=u-utrack
      vnm=v-vtrack
      unvnm=unv-utrack
      vnvnm=vnv-vtrack
   else
      u=missval
      v=missval
      unv=missval
      vnv=missval
      unm=missval
      vnm=missval
      unvnm=missval
      vnvnm=missval
   endif

print *,'writing out data at level ',i,' pressure = ',plevs(i)
   uavg(i)=u
   vavg(i)=v
   unvavg(i)=unv
   vnvavg(i)=vnv
   unmavg(i)=unm
   vnmavg(i)=vnm
   unvnmavg(i)=unvnm
   vnvnmavg(i)=vnvnm
   close(20)
enddo
 
close(20)

print *, numdrops,' soundings read in '

!DEEP      
ushear=uavg(9) - uavg(2)
vshear=vavg(9) - vavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg

plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(1,1,1)=ushear
sheardat(1,2,1)=vshear
sheardat(1,3,1)=shearmag
sheardat(1,4,1)=sheardir
sheardat(1,5,1)=plotdir


open(unit=21,file='SHEAR.dat',status='new',form='formatted')
write(21,'(A)' ) '200mb - 850mb DEEP SHEAR'
write(21,'(A10,F8.3,X,F8.3,X,A11,F8.3,X,F8.3)' ) '200mb U V ',uavg(9),vavg(9),' 850mb U V ',uavg(2),vavg(2)
write(21,'(2(A2,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)') 'U=',ushear,'V=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir 

ushear=unvavg(9) - unvavg(2)
vshear=vnvavg(9) - vnvavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(1,1,2)=ushear
sheardat(1,2,2)=vshear
sheardat(1,3,2)=shearmag
sheardat(1,4,2)=sheardir
sheardat(1,5,2)=plotdir

write(21,'(A14,F8.3,X,F8.3,A15,F8.3,X,F8.3)' ) '200mb UNV VNV ',unvavg(9),vnvavg(9),' 850mb UNV VNV ',unvavg(2),vnvavg(2)
write(21,'(2(A2,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNV=',ushear,'VNV=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

print *, "DEEP LAYER STEERING"
ushear=unvavg(2)+unvavg(3)+unvavg(4)+unvavg(5)+unvavg(6)+unvavg(7)+unvavg(8)+unvavg(9)
vshear=vnvavg(2)+vnvavg(3)+vnvavg(4)+vnvavg(5)+vnvavg(6)+vnvavg(7)+vnvavg(8)+vnvavg(9)
ushear=ushear/8
vshear=vshear/8
shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg

plotdir=sheardir
print *, 'sheardir',sheardir
sheardir=270-sheardir
print *, 'sheardir',sheardir

if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

print *, 'u v mag dir ',ushear,vshear,shearmag, sheardir
motion(1,1)=shearmag
motion(1,2)=sheardir
motion(1,3)=plotdir
print *, "MID LEVEL STEERING"
ushear=unvavg(2)+unvavg(3)+unvavg(4)+unvavg(5)+unvavg(6)
vshear=vnvavg(2)+vnvavg(3)+vnvavg(4)+vnvavg(5)+vnvavg(6)
ushear=ushear/5
vshear=vshear/5
shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir

sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

motion(2,1)=shearmag
motion(2,2)=sheardir
motion(2,3)=plotdir
print *, 'u v mag dir ',ushear,vshear,shearmag, sheardir

print *, "LOW LEVEL STEERING"
ushear=unvavg(2)+vnvavg(3)
vshear=vnvavg(2)+vnvavg(3)
ushear=ushear/2
vshear=vshear/2
shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

motion(3,1)=shearmag
motion(3,2)=sheardir
motion(3,3)=plotdir
print *, 'u v mag dir ',ushear,vshear,shearmag, sheardir

ushear=unmavg(9) - unmavg(2)
vshear=vnmavg(9) - vnmavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(1,1,3)=ushear
sheardat(1,2,3)=vshear
sheardat(1,3,3)=shearmag
sheardat(1,4,3)=sheardir
sheardat(1,5,3)=plotdir

write(21,'(A14,F8.3,X,F8.3,A15,F8.3,X,F8.3)' ) '200mb UNM VNM ',unmavg(9),vnmavg(9),' 850mb UNM VNM ',unmavg(2),vnmavg(2)
write(21,'(2(A4,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNM=',ushear,'VNM=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

ushear=unvnmavg(9) - unvnmavg(2)
vshear=vnvnmavg(9) - vnvnmavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(1,1,4)=ushear
sheardat(1,2,4)=vshear
sheardat(1,3,4)=shearmag
sheardat(1,4,4)=sheardir
sheardat(1,5,4)=plotdir

write(21,'(A18,F8.3,X,F8.3,A8,F8.3,X,F8.3)' ) '200mb UNVNM VNVNM ',unvnmavg(9),vnvnmavg(9),' 850mb UNVNM VNVNM ',unvnmavg(2),vnvnmavg(2)
write(21,'(2(A6,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNVNM=',ushear,'VNVNM=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

!MID LEVEL
ushear=uavg(7) - uavg(3)
vshear=vavg(7) - vavg(3)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(2,1,1)=ushear
sheardat(2,2,1)=vshear
sheardat(2,3,1)=shearmag
sheardat(2,4,1)=sheardir
sheardat(2,5,1)=plotdir

write(21,'(A)' ) '300mb - 700mb MID LEVEL SHEAR'
write(21,'(A10,F8.3,X,F8.3,A11,F8.3,X,F8.3)' ) '300mb U V ',uavg(7),vavg(7),' 700mb U V ',uavg(3),vavg(3)
write(21,'(2(A2,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')  'U=',ushear,'V=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir           

ushear=unvavg(7) - unvavg(3)
vshear=vnvavg(7) - vnvavg(3)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(2,1,2)=ushear
sheardat(2,2,2)=vshear
sheardat(2,3,2)=shearmag
sheardat(2,4,2)=sheardir
sheardat(2,5,2)=plotdir

write(21,'(A14,F8.3,X,F8.3,X,A15,F8.3,X,F8.3)' ) '300mb UNV VNV ',unvavg(7),vnvavg(7),' 700mb UNV VNV ',unvavg(3),vnvavg(3)
write(21,'(2(A2,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNV=',ushear,'VNV=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

ushear=unmavg(7) - unmavg(3)
vshear=vnmavg(7) - vnmavg(3)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(2,1,3)=ushear
sheardat(2,2,3)=vshear
sheardat(2,3,3)=shearmag
sheardat(2,4,3)=sheardir
sheardat(2,5,3)=plotdir

write(21,'(A14,F8.3,X,F8.3,X,A15,F8.3,X,F8.3)' ) '300mb UNM VNM ',unmavg(7),vnmavg(7),' 700mb UNM VNM ',unmavg(3),vnmavg(3)
write(21,'(2(A4,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNM=',ushear,'VNM=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

ushear=unvnmavg(7) - unvnmavg(3)
vshear=vnvnmavg(7) - vnvnmavg(3)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(2,1,4)=ushear
sheardat(2,2,4)=vshear
sheardat(2,3,4)=shearmag
sheardat(2,4,4)=sheardir
sheardat(2,5,4)=plotdir

write(21,'(A18,F8.3,X,F8.3,X,A19,F8.3,X,F8.3)' ) '300mb UNVNM VNVNM ',unvnmavg(7),vnvnmavg(7),' 700mb UNVNM VNVNM ',unvnmavg(3),vnvnmavg(3)
write(21,'(2(A6,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNVNM=',ushear,'VNVNM=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir


!SHALLOW
ushear=uavg(5) - uavg(2)
vshear=vavg(5) - vavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(3,1,1)=ushear
sheardat(3,2,1)=vshear
sheardat(3,3,1)=shearmag
sheardat(3,4,1)=sheardir
sheardat(3,5,1)=plotdir

write(21,'(A)' ) '500mb - 850mb SHALLOW SHEAR'
write(21,'(A10,F8.3,X,F8.3,A11,F8.3,X,F8.3)' ) '500mb U V ',uavg(5),vavg(5),' 850mb U V ',uavg(2),vavg(2)
write(21,'(2(A2,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)') 'U=',ushear,'V=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

ushear=unvavg(5) - unvavg(2)
vshear=vnvavg(5) - vnvavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(3,1,2)=ushear
sheardat(3,2,2)=vshear
sheardat(3,3,2)=shearmag
sheardat(3,4,2)=sheardir
sheardat(3,5,2)=plotdir

write(21,'(A14,F8.3,X,F8.3,A15,F8.3,X,F8.3)' ) '500mb UNV VNV ',unvavg(7),vnvavg(7),' 850mb U V ',unvavg(2),vnvavg(2)
write(21,'(2(A4,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNV=',ushear,'VNV=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

ushear=unmavg(5) - unmavg(2)
vshear=vnmavg(5) - vnmavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(3,1,3)=ushear
sheardat(3,2,3)=vshear
sheardat(3,3,3)=shearmag
sheardat(3,4,3)=sheardir
sheardat(3,5,3)=plotdir

write(21,'(A14,F8.3,X,F8.3,A15,F8.3,X,F8.3)' ) '500mb UNM VNM ',unmavg(7),vnmavg(7),' 850mb UNM VNM ',unmavg(2),vnmavg(2)
write(21,'(2(A4,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNM=',ushear,'VNM=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

ushear=unvnmavg(5) - unvnmavg(2)
vshear=vnvnmavg(5) - vnvnmavg(2)

shearmag=sqrt(ushear**2+vshear**2)
sheardir=atan2(vshear,ushear)*rad2deg
plotdir=sheardir
sheardir=270-sheardir
if(sheardir.lt.0)then
   sheardir=sheardir+360
endif

sheardat(3,1,4)=ushear
sheardat(3,2,4)=vshear
sheardat(3,3,4)=shearmag
sheardat(3,4,4)=sheardir
sheardat(3,5,4)=plotdir

write(21,'(A18,F8.3,X,F8.3,A19,F8.3,X,F8.3)' ) '500mb UNVNM VNVNM ',unvnmavg(7),vnvnmavg(7),' 850mb UNVNM VNVNM ',unvnmavg(2),vnvnmavg(2)
write(21,'(2(A6,F8.3,X),A4,F8.3,X,A4,F7.2,X,A5,F7.2)')'UNVNM=',ushear,'VNVNM=',vshear,'MAG=',shearmag,'DIR=',sheardir,'PDIR=',plotdir

!SIG LEVEL WIND FOR PLOTTING
do i = 1, nlev
   ushear=uavg(i)
   vshear=vavg(i)
   shearmag=sqrt(ushear**2+vshear**2)
   sheardir=atan2(vshear,ushear)
   plotdir=sheardir
   sheardir=270-sheardir
   if(sheardir.lt.0)then
      sheardir=360+sheardir
   endif

   write(21,'(A2,F6.1,X,A2,F8.3,X,A2,F8.3,X,A5,F8.3,X,A5,F6.2,X,A7,F6.2)')'P=',plevs(i),'U=',ushear,'V=',vshear,'WSPD=',shearmag,&
        'WDIR=',sheardir,'PLOTDIR=',plotdir

   ushear=unvavg(i)
   vshear=vnvavg(i)
   shearmag=sqrt(ushear**2+vshear**2)
   sheardir=atan2(vshear,ushear)
   plotdir=sheardir
   sheardir=270-sheardir
   if(sheardir.lt.0)then
      sheardir=360+sheardir
   endif


   write(21,'(A2,F6.1,X,A4,F8.3,X,A4,F8.3,X,A5,F8.3,X,A5,F6.2,X,A7,F6.2)')'P=',plevs(i),'UNV=',ushear,'VNV=',vshear,'WSPD=',shearmag,&
         'WDIR=',sheardir,'PLOTDIR=',plotdir

   ushear=unmavg(i)
   vshear=vnmavg(i)
   shearmag=sqrt(ushear**2+vshear**2)
   sheardir=atan2(vshear,ushear)
   plotdir=sheardir
   sheardir=270-sheardir
   if(sheardir.lt.0)then
      sheardir=360+sheardir
   endif

   write(21,'(A2,F6.1,X,A4,F8.3,X,A4,F8.3,X,A5,F8.3,X,A5,F6.2,X,A7,F6.2)')'P=',plevs(i),'UNM=',ushear,'VNM=',vshear,'WSPD=',shearmag,&
   'WDIR=',sheardir,'PLOTDIR=',plotdir

   ushear=unvnmavg(i)
   vshear=vnvnmavg(i)
   shearmag=sqrt(ushear**2+vshear**2)
   sheardir=atan2(vshear,ushear)
   plotdir=sheardir
   sheardir=270-sheardir
   if(sheardir.lt.0)then
      sheardir=360+sheardir
   endif

   write(21,'(A2,F6.1,X,A6,F8.3,X,A6,F8.3,X,A5,F8.3,X,A5,F6.2,X,A7,F6.2)')'P=',plevs(i),'UNVNM=',ushear,'VNVNM=',vshear,'WSPD=',shearmag,&
    'WDIR=',sheardir,'PLOTDIR=',plotdir

enddo

print *, "finished writing level data"

open(unit=51,file='gradsshear.dat',status='unknown',form='unformatted',access='append')
open(unit=52,file='gradsshear.txt',status='unknown',form='formatted',access='append')

k=0

do i = 1, numdrops
   do j = 1, nlev
      write(51) sta(i),gradsdat(1,i,1),gradsdat(2,i,1), 0, 1, 0
      write(51) plevs(j),plevs(j),gradsdat(3,i,j),gradsdat(4,i,j),gradsdat(5,i,j),gradsdat(6,i,j),&
                gradsdat(7,i,j),gradsdat(8,i,j),gradsdat(9,i,j),gradsdat(10,i,j)
      write(52,'(A8,X,F8.3,X,F8.3,3(X,I1))') sta(i),gradsdat(1,i,1),gradsdat(2,i,1), 0, 1, 0
      write(52,'(9(F8.3,X))') plevs(j),gradsdat(3,i,j),gradsdat(4,i,j),gradsdat(5,i,j),gradsdat(6,i,j),&
                gradsdat(7,i,j),gradsdat(8,i,j),gradsdat(9,i,j),gradsdat(10,i,j)
   enddo
enddo
write(51) sta(numdrops), gradsdat(1,numdrops,1),gradsdat(2,numdrops,1),0,0,0

open(unit=55,file='bounds.txt',status='new',form='formatted')
write(55,'(F5.1,X,F5.1,X,F6.1,X,F6.1)') minlat,maxlat,minlon,maxlon
close(55)

open(unit=56,file='levshear.txt',status='new',form='formatted')
write(56,'(3(F5.2,X,F6.1,X,F6.1,X)') sheardat(1,3,4),sheardat(1,4,4),sheardat(1,5,4),&
      sheardat(2,3,4),sheardat(2,4,4),sheardat(2,5,4),sheardat(3,3,4),sheardat(3,4,4),&
      sheardat(2,5,4)
close(56)

open(unit=57,file='steering.txt',status='new',form='formatted')
write(57,'(3(F5.2,X,F6.1,X),F6.1,X') motion(1,1),motion(1,2),motion(1,3),motion(2,1),motion(2,2),&
     &motion(2,3),motion(3,1),motion(3,2),motion(3,3)
close(57)




ENDPROGRAM SHEARFROMDROPS
