
*CIMSS Colors 
*100-250 = Cycan (5)
*251-350 = Yellow (7)
*351-500 = Green (3)

*SHEAR Levels
*200-850 Deep
*300-700 Mid
*500-850 Shallow

*STEERING Levels
*850-700 Low
*850-400 Mid
*850-200 Deep

'open gradsshear.ctl'
'set display color white'
'clear'

sdat=read('bounds.txt')
latmin=subwrd(sdat,2)
latmin=latmin - 0.5
say latmin
latmax=subwrd(sdat,3)
latmax=latmax + 0.65
say latmax
lonmin=subwrd(sdat,4)
lonmin=lonmin - 0.5
say lonmin
lonmax=subwrd(sdat,5)
lonmax=lonmax + 0.5
say lonmax

*TOP PLOT
*U total 
'set vpage 0 2.75 4.25 8.5'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

levnow=200
'set lev 'levnow
'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd u;v'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd const(u,0);const(v,0);0;0;0;0'

*U no vortex
'set vpage 2.75 5.5 4.25 8.5'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'

'set lev 'levnow
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd unv;vnv'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd const(unv,0);const(vnv,0);0;0;0;0'

*U no motion
'set vpage 5.5 8.25 4.25 8.5'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'

'set lev 'levnow
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd unm;vnm'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd const(unm,0);const(vnm,0);0;0;0;0'

*U no vortex no motion
'set vpage 8.25 11.0 4.25 8.5'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'

'set lev 'levnow
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd unvnm;vnvnm'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd const(unvnm,0);const(vnvnm,0);0;0;0;0'

*BOTOM PLOT 850mb
levnow=850

*U total
'set vpage 0 2.75 0.0 4.25'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set lev 'levnow
'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd u;v'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd const(u,0);const(v,0);0;0;0;0'

*U no vortex
'set vpage 2.75 5.5 0.0 4.25'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'

'set lev 'levnow
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd unv;vnv'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd const(unv,0);const(vnv,0);0;0;0;0'

*U no motion
'set vpage 5.5 8.25 0.0 4.25'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'

'set lev 'levnow
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd unm;vnm'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd const(unm,0);const(vnm,0);0;0;0;0'

*U no vortex no motion
'set vpage 8.25 11.0 0.0 4.25'
'set parea 0.25 5.25 0.25 8.25'
'set grads off'
'set mpdset hires'

'set lev 'levnow
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd unvnm;vnvnm'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd const(unvnm,0);const(vnvnm,0);0;0;0;0'

' set vpage 0 11.0 0 8.5 ' 
' set string 1 c 10 0'
' draw string 5.5 8.4 200mb WIND'
' draw string 1.375 8.0 Earth Relative'
' draw string 4.125 8.0 Vortex Removed'
' draw string 6.875 8.0 Storm Motion Removed'
' draw string 9.625 8.0 Vortex and Motion Removed'

' draw string 5.5 4.4 850mb WIND'
' draw string 1.375 4.0 Earth Relative'
' draw string 4.125 4.0 Vortex Removed'
' draw string 6.875 4.0 Storm Motion Removed'
' draw string 9.625 4.0 Vortex and Motion Removed'

