
*CIMSS Colors 
*100-250 = Cycan (5)
*251-350 = Yellow (7)
*351-500 = Green (3)

*SHEAR Levels
*200-850 Deep
*300-700 Mid
*500-850 Shallow

*STEERING Levels
*850-700 Low
*850-400 Mid
*850-200 Deep

sdat=read('deepshear.txt')
shdm=subwrd(sdat,2)
shdd=subwrd(sdat,3)
shdmnv=subwrd(sdat,4)
shddnv=subwrd(sdat,5)
sspd=subwrd(sdat,6)
sdir=subwrd(sdat,7)
sdat=read('bounds.txt')
latmin=subwrd(sdat,2)
say latmin
latmax=subwrd(sdat,3)
say latmax
lonmin=subwrd(sdat,4)
say lonmin
lonmax=subwrd(sdat,5)
say lonmax

'open gradsshear.ctl'
'set display color white'
'clear'
'set vpage 0 11 0 8.5'
'set parea 0.75 8 0.75 8.0'
'set grads off'
'set mpdset hires'
'set lat 'latmin' 'latmax
'set lon 'lonmin' 'lonmax

levnow=850
'set lev 'levnow
'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd u;v'
'set gxout model'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 1'
'd const(u,0);const(v,0);0;0;0;0'

levnow=200
'set lev 'levnow
'set gxout barb'
'set digsiz 0.15'
'set dignum 1'
'set ccolor 5'
'd u;v'

'set string 1 c 1 0'
'draw string 5.5 7.7 850mb WIND'
'set string 5 c 1 0'
'draw string 5.5 7.5 200mb WIND'

rangle = sdir
if(rangle < 0.0)
   rangle = rangle + 360
endif

xdist=math_cos(rangle)
ydist=math_sin(rangle)

'set string 1 l 1 0'
'draw string 8.1 6.7 850-200mb STEERING'
'draw string 8.1 6.5 'sspd'kts 'sdir'deg'

*box x = 8.1 9.1
*    y = 6.5 7.5

if(xdist < 0)
   x1 = 9.3
endif

if(xdist >= 0)
   x1 = 8.3
endif

if(ydist < 0 )
   if(ydist < -0.5)
      y1 = 6.3
    endif
    if(ydist >= -0.5)
      y1 = 5.8
    endif
endif

if (ydist > 0)
  if(ydist < 0.5)
     y1=5.8
   endif
   if( ydist >= 0.5) 
      y1 = 5.3
   endif
endif

   x2 = x1 + xdist
   y2 = y1 + ydist

   xdist=x2-x1
   ydist=y2-y1
   xh = x2 - (xdist/3)
   yh = y2 - (ydist/3)


'draw line 'x1' 'y1' 'x2' 'y2
x1 = xh - (0.3 * math_sin(rangle))
y1 = yh + (0.3 * math_cos(rangle))


'draw line 'x1' 'y1' 'x2' 'y2
x1 = xh + (0.3 * math_sin(rangle))
y1 = yh - (0.3 * math_cos(rangle))
'draw line 'x1' 'y1' 'x2' 'y2

rangle = shdd
if(rangle < 0.0)
   rangle = rangle + 360
endif

xdist=math_cos(rangle)
ydist=math_sin(rangle)

'set string 1 l 1 0'
'draw string 8.1 5.1 850-200mb SHEAR'
'draw string 8.1 4.9 'shdm'kts 'shdd'deg'

*box x = 8.1 9.1
*    y = 6.5 7.5

if(xdist < 0)
   x1 = 9.3
endif

if(xdist >= 0)
   x1 = 8.3
endif

if(ydist < 0 )
   if(ydist < -0.5)
      y1 = 4.7
    endif
    if(ydist >= -0.5)
      y1 = 4.2
    endif
endif

if (ydist > 0)
  if(ydist < 0.5)
     y1=4.2
   endif
   if( ydist >= 0.5) 
      y1 = 3.7
   endif
endif

   x2 = x1 + xdist
   y2 = y1 + ydist

   xdist=x2-x1
   ydist=y2-y1
   xh = x2 - (xdist/3)
   yh = y2 - (ydist/3)


'draw line 'x1' 'y1' 'x2' 'y2
x1 = xh - (0.3 * math_sin(rangle))
y1 = yh + (0.3 * math_cos(rangle))


'draw line 'x1' 'y1' 'x2' 'y2
x1 = xh + (0.3 * math_sin(rangle))
y1 = yh - (0.3 * math_cos(rangle))
'draw line 'x1' 'y1' 'x2' 'y2

rangle = shddnv
if(rangle < 0.0)
   rangle = rangle + 360
endif

xdist=math_cos(rangle)
ydist=math_sin(rangle)


'set string 1 l 1 0'
'draw string 8.1 3.5 850-200mb SHEAR NO VORTEX'
'draw string 8.1 3.3 'shdmnv'kts 'shddnv'deg'

*box x = 8.1 9.1
*    y = 6.5 7.5

if(xdist < 0)
   x1 = 9.3
endif

if(xdist >= 0)
   x1 = 8.3
endif

if(ydist < 0 )
   if(ydist < -0.5)
      y1 = 3.1
    endif
    if(ydist >= -0.5)
      y1 = 2.6
    endif
endif

if (ydist > 0)
  if(ydist < 0.5)
     y1=2.6
   endif
   if( ydist >= 0.5) 
      y1 = 2.1
   endif
endif

   x2 = x1 + xdist
   y2 = y1 + ydist

   xdist=x2-x1
   ydist=y2-y1
   xh = x2 - (xdist/3)
   yh = y2 - (ydist/3)


'draw line 'x1' 'y1' 'x2' 'y2
x1 = xh - (0.3 * math_sin(rangle))
y1 = yh + (0.3 * math_cos(rangle))


'draw line 'x1' 'y1' 'x2' 'y2
x1 = xh + (0.3 * math_sin(rangle))
y1 = yh - (0.3 * math_cos(rangle))
'draw line 'x1' 'y1' 'x2' 'y2


