#!/bin/sh

starttime=201908311800
ctime=201908312100
endtime=201909010000
logfile=get_shear.log

year=`echo $starttime | cut -c1-4`

echo "getting shear from drops within timerange "$starttime" "$endtime > $logfile

#atlantic epacific UZPN
basin=atlantic
dropdir=/lfs3/projects/hfip-hda/OBSDATA/${year}/public/data/dropsonde/${basin}
advdir=/public/data/nhc/advisories

mkdir WORK
cp wud.x WORK/
cp get_shear.x WORK/
cp plot_shear.gs WORK/
cp plot_shearvec.gs WORK/
cp station_data_map WORK/

cd WORK
mydir=`pwd`

sdate=`echo $starttime | cut -c1-8`
stime=`echo $starttime | cut -c9-12`
edate=`echo $endtime | cut -c1-8`
etime=`echo $endtime | cut -c9-12`

#get drops
#cd $dropdir
#for i in `ls $sdate*`
#do 
#   droptime=`echo $i | cut -c1-12`
#   if [ $droptime -ge $starttime ] && [ $droptime -le $endtime ]
#   then
#      cp $i $mydir/
#   fi
#done   

#cd $mydir
#process drops to make hsa file ... use wudget position estimate
#for i in ls `$sdate*`
#do
#   strings $i > ${i}.txt
#   ./wud.x ${i}.txt
#   cat fort.15 >> DROP_HSA.txt
#   rm ${i}.txt
#   echo "drop " $i >>$logfile
#done
#if [ $startdate -ne $enddate ]
#then 
#   for i in ls `$edate*`
#   do
#      strings $i > ${i}.txt
#      ./wud.x ${i}.txt
#      cat fort.15 >> DROP_HSA.txt
#      rm ${i}.txt
#      echo "drop " $i >>$logfile
#done
#remove fort*
#Pick advisory closest to center time
#cd $advdir
#for i in `ls $year*`
#do
#   advtime=`echo $i | cut -c1-12`
#   if [ $advtime -ge $starttime -a $advtime -le $endtime ]
#   then
#      cp $i ${mydir}/${i}.adv
#   fi
#done

cd $mydir

mintime=2400
echo "ADVISORIES" >> obslist

#for i in `ls *adv`
#do
i=201908312049.KNHC.adv
   advdate=`echo $i | cut -c1-8`
   advtime=`echo $i | cut -c9-12`

echo "advisory date time" $advdate $advtime

   if [ $sdate -eq $advdate ]
   then
       tdiff1=`expr $advtime - $stime`
   else
       tdiff1=`expr $advtime + 2400 - $stime`
   fi
 
   if [ $edate -eq $advdate ]
   then
      tdiff2=`expr $etime - $advtime`
   else
      tdiff2=`expr $etime + 2400 - $advtime`
   fi

   if [ $tdiff2 -ge $tdiff1 ]
   then
      tdiff=`expr $tdiff2 - $tdiff1`
   else
      tdiff=`expr $tdiff1 - $tdiff2`
   fi

   if [ $tdiff -lt $mintime ]
   then
      mintime=$tdiff
      advuse=$i
   fi
#done

   
advtime=`grep WAS $advuse | cut -d'/' -f2 | cut -c1-4`
echo "advtime "$advtime
clat=`grep WAS $advuse | cut -d'/' -f2 | cut -d' ' -f6`

shift=0

if [ -z $clat ]
then
   clat=`grep WAS $advuse | cut -d'/' -f2 | cut -d' ' -f7`
   shift=1
   lat=`echo $clat | cut -c1-3`
   hem=`echo $clat | cut -c4`
else
   lat=`echo $clat | cut -c1-4`
   hem=`echo $clat | cut -c5`
fi

echo "clat hem "$lat" "$hem

if [ $hem == "S" ] 
then
   clat=-${lat}
else
   clat=${lat}
fi

echo "clat "$clat

shift=`expr $shift + 7`
clon=`grep WAS $advuse | cut -d'/' -f2 | cut -d' ' -f${shift}`

if [ -z $clon ]
then
   echo "clon==blank"
   shift=`expr $shift + 1`
   clon=`grep WAS $advuse | cut -d'/' -f2 | cut -d' ' -f${shift}`
   lon=`echo $clon | cut -c1-4`
   hem=`echo $clon | cut -c5`
else
   lon=`echo $clon | cut -c1-5`
   hem=`echo $clon | cut -c6`
fi

echo "clon hem "$lon" "$hem

if [ $hem == "W" ]
then
   clon=-${lon}
else
   clon=${lon}
fi

echo "clon "$clon


sdir=`grep MOVEMENT $advuse | cut -d' ' -f7`

shift=0
echo "sdir "$sdir

if [ -z $sdir ]
then
   sdir=`grep MOVEMENT $advuse | cut -d' ' -f8`
   shift=1
   echo "sdir= blank "$sdir

   if [ -z $sdir ]
   then
      sdir=`grep MOVEMENT $advuse | cut -d' ' -f9`
      echo "sdir=blank " $sdir
      shift=2
   fi
fi

echo "shift field by "$shift
shift=`expr $shift + 10`
echo "speed is field # "$shift

sspd=`grep MOVEMENT $advuse | cut -d' ' -f${shift}`
echo "sspd " $sspd

if [ -z $sspd ]
then
   echo "sspd = blank"
   shift=`expr $shift + 1`
   echo "field is now "$shift
   sspd=`grep MOVEMENT $advuse | cut -d' ' -f${shift}`
   if [ -z $sspd ]
   then
      echo "sspd = blank"
      shift=`expr $shift + 1`
      echo "field is now "$shift
      sspd=`grep MOVEMENT $advuse | cut -d' ' -f${shift}`
   fi
fi
echo "sspd "$sspd

fixtime=`echo $advuse | cut -c1-12`
echo "processed advisory "$advuse
echo "speed "$sspd" dir "$sdir" clat "$clat" clon "$clon" advtime "$fixtime
./get_shear.x $sspd $sdir $clat $clon $fixtime


